package com.FranckBarbier.Java._Try_with_resources;

public class My_class implements java.io.Serializable {

    public static void main(String[] args) {

        My_class c = new My_class();
        String filename = "My_class.ser"; // 'public class My_class implements java.io.Serializable...'

        java.io.FileOutputStream fos = null;
        java.io.ObjectOutputStream ous = null;
        try /* (java.io.ObjectOutputStream ous = new java.io.ObjectOutputStream(fos)) */ {
            fos = new java.io.FileOutputStream(filename);
            ous = new java.io.ObjectOutputStream(fos);
            ous.writeObject(c);
        } catch (java.io.FileNotFoundException fnfe) {
            // 'fos = new java.io.FileOutputStream(filename);' failed
        } catch (java.io.IOException ioe) {
            // 'ous = new java.io.ObjectOutputStream(fos);' or 'ous.writeObject(c);' failed
        } finally {
            if (ous != null) {
//                ous.close(); // Compilation problem here!              
            }
        }

        try ( java.io.ObjectOutputStream ous_plus = new java.io.ObjectOutputStream(fos)) {
            ous_plus.writeObject(c);
        } catch (java.io.IOException ioe) {
            // 'ous = new java.io.ObjectOutputStream(fos);' or 'ous.writeObject(c);' failed
        }
    }
}
